package com.fr.plugin.xx.wechat.img.output.conf;

import com.fr.config.*;
import com.fr.config.holder.Conf;
import com.fr.config.holder.factory.Holders;
import com.fr.stable.StringUtils;


/**
 * @author xx
 * @since 2021/12/04
 */
@Visualization(category = "企微推送调度配置")
public class ImgPushConfig extends DefaultConfiguration {

    private static volatile ImgPushConfig config = null;

    public static ImgPushConfig getInstance() {
        if (config == null) {
            config = ConfigContext.getConfigInstance(ImgPushConfig.class);
        }
        return config;
    }

    @Identifier(value = "debugSwitch", name = "插件调试开关", description = "日志调试模式", status = Status.SHOW)
    private Conf<Boolean> debugSwitch = Holders.simple(true);

    public Boolean getDebugSwitch() {
        return this.debugSwitch.get();
    }

    public void setDebugSwitch(Boolean debugSwitch) {
        this.debugSwitch.set(debugSwitch);
    }

    @Identifier(value = "host", name = "企微接口地址", description = "http://{{ip}}:{{port}}", status = Status.SHOW)
    private Conf<String> host = Holders.simple(StringUtils.EMPTY);
    public String getHost() {
        return host.get();
    }

    public void setHost(String host) {
        this.host.set(host);
    }

    @Identifier(value = "apiUserCode", name = "系统编码", description = "企业微信系统编码", status = Status.SHOW)
    private Conf<String> apiUserCode = Holders.simple(StringUtils.EMPTY);

    public String getApiUserCode() {
        return apiUserCode.get();
    }

    public void setApiUserCode(String apiUserCode) {
        this.apiUserCode.set(apiUserCode);
    }

    @Identifier(value = "apiUserSecret", name = "系统秘钥", description = "企业微信系统秘钥", status = Status.SHOW)
    private Conf<String> apiUserSecret = Holders.simple(StringUtils.EMPTY);

    public String getApiUserSecret() {
        return apiUserSecret.get();
    }

    public void setApiUserSecret(String apiUserSecret) {
        this.apiUserSecret.set(apiUserSecret);
    }

    @Override
    public Object clone() throws CloneNotSupportedException {
        ImgPushConfig cloned = (ImgPushConfig) super.clone();
        cloned.debugSwitch = (Conf<Boolean>) debugSwitch.clone();
        cloned.host = (Conf<String>) host.clone();
        return cloned;
    }


    public boolean isConfiged() {
        return StringUtils.isNotBlank(getHost());
    }
}
