package com.fr.plugin.xx.wechat.img.output.entity;

import com.fr.schedule.base.bean.output.BaseOutputAction;
import com.fr.schedule.base.entity.AbstractScheduleEntity;
import com.fr.schedule.base.type.RunType;
import com.fr.third.fasterxml.jackson.annotation.JsonSubTypes;

/**
 * @Author xx
 * @Date 2020/9/15
 * @Description
 **/
@JsonSubTypes.Type(value = OutputWebHook.class, name = "OutputWebHook")
public class OutputWebHook extends BaseOutputAction {

    private static final long serialVersionUID = 8245931480823179622L;
    private String hookUrl = null;

    public OutputWebHook() {
        super();
    }

    @Override
    public boolean willExecuteByUser() {
        return true;
    }

    @Override
    public RunType runType() {
        return RunType.SEND_FILE;
    }

    @Override
    public Class<? extends AbstractScheduleEntity> outputActionEntityClass() {
        return WebHookEntity.class;
    }

    @Override
    public AbstractScheduleEntity createOutputActionEntity() {
        return (new WebHookEntity()).id(this.getId()).hookUrl(this.hookUrl);
    }

    @Override
    public OutputWebHook id(String id) {
        setId(id);
        return this;
    }

    public String getHookUrl() {
        return hookUrl;
    }

    public void setHookUrl(String hookUrl) {
        this.hookUrl = hookUrl;
    }

    public OutputWebHook hookUrl(String hookUrl) {
        setHookUrl(hookUrl);
        return this;
    }
}
