package com.fr.plugin.xx.wechat.img.output.service;

import com.fr.plugin.xx.wechat.img.output.ImgConfigDBAccessProvider;
import com.fr.plugin.xx.wechat.img.output.LogUtils;
import com.fr.plugin.xx.wechat.img.output.dao.ImgConfigDao;
import com.fr.plugin.xx.wechat.img.output.entity.ImgConfigEntity;
import com.fr.stable.db.action.DBAction;
import com.fr.stable.db.dao.DAOContext;
import com.fr.stable.query.QueryFactory;
import com.fr.stable.query.restriction.RestrictionFactory;

import java.util.ArrayList;
import java.util.List;

/**
 * @Author xx
 * @Date 2022/7/16
 * @Description
 **/
public class ImgConfigService {

    /**
     * 获取分组要执行的配置
     * @param name
     * @return
     */
    public static List<ImgConfigEntity> getListByUpName(String name) {
        try {
            return ImgConfigDBAccessProvider.getDbAccessor().runQueryAction(new DBAction<List<ImgConfigEntity>>() {
                @Override
                public List<ImgConfigEntity> run(DAOContext daoContext) throws Exception {
                    return daoContext.getDAO(ImgConfigDao.class).find(QueryFactory.create().addRestriction(RestrictionFactory.eq("upname", name)));
                }
            });
        } catch (Exception e) {
            LogUtils.error(e.getMessage(), e);
        }
        return new ArrayList<>();
    }
}
